<ui:composition
    xmlns="http://www.w3.org/1999/xhtml"
    xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
    xmlns:h="http://xmlns.jcp.org/jsf/html"
    xmlns:p="http://primefaces.org/ui"
    xmlns:f="http://java.sun.com/jsf/core"
    xmlns:jsf="http://xmlns.jcp.org/jsf">
    <div class="sidenav">
    <p id="bookgenres">#{msgs.genres}</p>
    <!--Have a filter for the genre of your search when clicking on one of the genre displayed-->
    <ui:repeat var="entry" value="#{theBooks.genreMap.entrySet().toArray()}" varStatus="status">
        <h:form>
            <h:commandLink action="#{theBooks.searchBooksWithGenre(entry.key)}">#{entry.key}<span id="numOfBooksInGenre"> (#{entry.value})</span></h:commandLink>
        </h:form>
    </ui:repeat>
    </div>
    <div id="centerErrorDiv"> 
        <!--Displaying the error when searching for a book-->
        <h:outputText value="#{msgs.noBookTitle} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'bookTitle'}"/>
        <h:outputText value="#{msgs.noAuthorName} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'authorName'}"/>
        <h:outputText value="#{msgs.noPublisher} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'publisher'}"/>
        <h:outputText value="#{msgs.noIsbn} &#34;#{theBooks.searchTerm}&#34;" rendered="#{empty theBooks.bookList and theBooks.selectBy eq 'isbn'}"/>
    </div>
    <p:dataTable id="browseTable" value="#{theBooks.bookList}" var="aBook" binding="#{table}" 
                 rendered="#{not empty theBooks.bookList}" rows="5" paginator="true"
                 paginatorTemplate="{FirstPageLink} {PreviousPageLink} {NextPageLink} {LastPageLink}"
                 paginatorPosition="top">
        <p:column class="browsebook">
            <div class="containerBrowsePage">
                <div class="bookcover">
                    <h:graphicImage library="images" name="coverImages/#{aBook.imageUrl}" height="150" width="90" />
                </div>
                <div class="bookinfo">
                    <p>
                        <!--Lead to the book page when clicking on the title-->
                        <h:form>
                            <h:commandLink class="aBookTitle" action="#{theBooks.showSelectedBook(aBook,user.userId)}">#{aBook.title}</h:commandLink><br/>
                        </h:form>
                        <span class="bookauthor">#{msgs.by} #{aBook.authorId.name}</span><span class="seperator"> | </span><h:outputText styleClass="bookdate" value="#{aBook.dataPublication}" ><f:convertDateTime pattern="yyyy-MM-dd"/></h:outputText><br/>
                        <span class="bookprice" jsf:rendered="#{aBook.salePrice eq aBook.listPrice}">CDN$ <span class="price">#{aBook.listPrice}</span></span>
                        <span class="bookprice" jsf:rendered="#{aBook.salePrice ne aBook.listPrice}">CDN$ <span id="crossListPrice">#{aBook.listPrice}</span><span class="price"> #{aBook.salePrice}</span></span>
                    </p>
                    <!--Show the description of the book when clicking on the arrows-->
                    <p class="bookdescription" id="description#{table.rowIndex+1}">#{aBook.description}</p>
                </div>
                <div class="boxArrows" id="box#{table.rowIndex+1}" onclick="expand(this.id)">
                    <span></span>
                    <span></span>
                    <span></span>
                </div>
            </div>
        </p:column>
    </p:dataTable>
</ui:composition>